/**
 * Copyright (c) 2006 Sascha Grau
 * contact: rostar@graui.de
 */

#ifndef GRAPH_EXPORT_H_
#define GRAPH_EXPORT_H_

#include <iostream>
#include <fstream>

#include "../ds/graph.h"
#include "graphioexception.h"

class GraphExport {

private:
    static const std::string DOT_HEADER;

    static const unsigned int colornum = 14;
    static const std::string colors[];

public:
    static const unsigned long ALL = ULONG_MAX;

    static void toDotStream(std::ostream& out, Graph* g, 
                            unsigned long forest = ALL);
    static void toDotFile(std::string path, Graph* g, 
                        unsigned long forest = ALL)
                        throw(GraphIOException);
    static void printGraph(Graph* g);

};

#endif /* GRAPH_EXPORT_H_*/
