/**
 * Copyright (c) 2006 Sascha Grau
 * contact: rostar@graui.de
 */


#include "../io/graphfactory.h"
#include "../io/graphexport.h"

int main() {

    Graph* g = NULL;

    bool catched = false;
    try {
        g = GraphFactory::fromFile("notexistent_4435452fdfs245erwdf45");
    } catch(GraphIOException e) {
        catched = true;
    }
    if (!catched) {
        std::cout << "Graph import file handling error" << std::endl;
        return -1;
    }

    try {
        g = GraphFactory::fromFile("test.dot");
    } catch(GraphIOException e) {
        std::cout << e.getCause() << std::endl;
    }

    std::cout << g->edges.length() << std::endl;

    DLListIterator<Edge*>* it = g->edges.iterator();
    while(!it->endReached()) {
        Edge* e = it->getElem();
        std::cout << e->a->id << " -- " << e->b->id << " cost " << e->cost << std::endl;
        it->next();
    }
    delete it;

    GraphExport::toDotFile("output.dot", g, GraphExport::ALL);

/*
    DLListIterator<Edge*> eit;
    GraphFactory* gf = new GraphFactory();
    g = gf->permuteGraphFromFile("test.dot");
    long int cnt = 0;

    do {
        cnt++;
        eit.reset(&g->edges);
        std::cout << cnt << ":";
        while(!eit.endReached()) {
            Edge* e = eit.getElem();
            std::cout << " " << e->cost;
            eit.next();
        }
        std::cout << std::endl;

        delete g;
        g = gf->permuteGraph();
    } while(g != NULL);

    delete gf;
*/
}

