// http://www.imada.sdu.dk/Research/Graphcol/new_problems.html

#include <math.h>
#include "vn_graph.h"

histogram_t geng_reader(FILE* f) {
  char *s;
  int i=0,n,Delta,omega,chi,gap;
  histogram_t gaps=histogram_new("gaps");
  graph_t g;
  while ((s=geng_getline(f))) {
    i++;
    if (i%1000000==0) printf("i=%d g=%s",i,s);
    g=geng_stringtograph(s);
    //printf("i=%d s=%s",i,s);
    Delta=graph_max_degree(g);
    omega=graph_clique_number(g);
    if (omega<Delta-1) {
      chi=graph_chromatic_number(g,1000);
      if (chi==0)
        printf("timeout at g=%s\n",s);
      else {
        gap=(omega+Delta)-2*(chi-1);
        //printf("gap=%d\n",gap);
        if (gap<0) { 
          n=geng_graphsize(s);
          printf("counterexample: n=%d Delta=%d omega=%d chi=%d g=%s\n",n,Delta,omega,chi,s);
        } else 
          histogram_add(gaps,gap);
      }
    }
    if (s) free(s);
    graph_clear(g);
  }
  return gaps;
}

int main(int argc, char* argv[]) {
  histogram_t gaps=geng_reader(stdin);
  histogram_show(gaps);
  return 0;
}
